#include<Talkthrough.h>
#include <fract.h>
#include <filter.h>


volatile int OldSigma4=0, OldDelta1=0, OldDelta2=0, OldDelta3=0,Sigma1=0,
Sigma2=0,OldSigma5=0,OldDelta4=0;
volatile int  Result=0;
volatile int Sigma4=0,Sigma3=0,Delta1=0,Delta2=0,Delta3=0,Sigma5=0,Delta4=0,OldSigma3=0;

fract16 input[Size];




extern fir_state_fr16 state1;	

extern fir_state_fr16 state2;	

extern fir_state_fr16 state3;

extern fir_state_fr16 state4;


int GetData(int *,int,int);

section ("sdram0") fract16 out_fir_A[(Size + NUM_TAPS4 - 1)];

section ("sdram0") fract16 out_fir_A1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_A2[Size + NUM_TAPS2 - 1];

section ("sdram0") fract16 out_fir_A3[Size + NUM_TAPS3 - 1];



section ("sdram0") fract16 out_fir_B[(Size + NUM_TAPS4 - 1)];

section ("sdram0") fract16 out_fir_B1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_B2[Size + NUM_TAPS2 - 1];

section ("sdram0") fract16 out_fir_B3[Size + NUM_TAPS3 - 1];



section ("sdram0") fract16 out_fir_C[(Size + NUM_TAPS4 - 1)];

section ("sdram0") fract16 out_fir_C1[Size + NUM_TAPS1 - 1];

section ("sdram0") fract16 out_fir_C2[Size + NUM_TAPS2 - 1];

section ("sdram0") fract16 out_fir_C3[Size + NUM_TAPS3 - 1];

int test[Size];

extern int process_index;
extern int Buf_Index;


extern void Process_Data(void);

//---5th order CIC to reconstruct the PDM data----//

void filter(int *buff)

{
int i,j,l;

	for(j=0;j<Size;j++)

{
	OldSigma5 = Sigma5;          
	OldDelta1 = Delta1;          
	OldDelta2 = Delta2;          
	OldDelta3 = Delta3;           
	OldDelta4 = Delta4;

		for(i=0; i<8; i++){
		   Sigma1 += GetData(buff,j,i);     
		   Sigma2 += Sigma1;         
		   Sigma3 += Sigma2;         
		   Sigma4 += Sigma3;        
		   Sigma5 += Sigma4;        
		}
	
	Delta1 = Sigma5 - OldSigma5; 
	Delta2 = Delta1 - OldDelta1; 
	Delta3 = Delta2 - OldDelta2; 
	Delta4 = Delta3 - OldDelta3; 
	Result = Delta4 - OldDelta4; 

	input[j] =Result;
	
  
	}
	
	
	
	if(Buf_Index==0)
	{

    
	
		
		    fir_decima_fr16(input, out_fir_A1, Size, &state1);
		    
	        fir_decima_fr16(out_fir_A1, out_fir_A2, Size/2, &state2);
	        
       //   fir_decima_fr16(out_fir_A2, out_fir_A3, Size/4, &state3);
             
	        fir_fr16(out_fir_A2, out_fir_A, Size/4, &state4);
	        
	     process_index=1;
	}
	
	else if(Buf_Index==1)
			{

	        fir_decima_fr16(input, out_fir_B1, Size, &state1);
		    
	        fir_decima_fr16(out_fir_B1, out_fir_B2, Size/2, &state2);
	        
        //  fir_decima_fr16(out_fir_B2, out_fir_B3, Size/4, &state3);
             
	        fir_fr16(out_fir_B2, out_fir_B, Size/4, &state4);
	        
	     process_index=2;

	}
	
	else if(Buf_Index==2)
	{

            fir_decima_fr16(input, out_fir_C1, Size, &state1);
		    
	        fir_decima_fr16(out_fir_C1, out_fir_C2, Size/2, &state2);
	        
          //  fir_decima_fr16(out_fir_C2, out_fir_C3, Size/4, &state3);
             
	        fir_fr16(out_fir_C2, out_fir_C, Size/4, &state4);
	   
         process_index=3;
	}
	
}

int GetData(int *buffer,int word, int bit)
{ 
	int current_word = buffer[word];
	int current_bit;
	
	current_word>>= bit;
	current_bit = current_word & 0x1;
	
	return current_bit;
	
	
}